<?php

require('includes/top.php');

/* уже залогинен? марш на главную! */
if (isset($_SESSION['customer_id'])) {
//    os_redirect(os_href_link(FILENAME_ACCOUNT, '', 'SSL')); // TODO а может не надо?
}
/* включи куки! */
if ($session_started == false) {
//    os_redirect(os_href_link(FILENAME_COOKIE_USAGE)); // TODO а может не надо?
}

/* include.php*/
//$path_extra = dirname(dirname(dirname(__FILE__)));
$path_extra = "modules/plugins/openid/";        // TODO прозреваю что неправильно так делать
$path = ini_get('include_path');
$path = $path_extra . PATH_SEPARATOR . $path;
ini_set('include_path', $path);

function displayError($message) {
    $error = $message;
    include 'modules/plugins/openid/index.php';
    exit(0);
}

    require_once "Auth/OpenID/Consumer.php";
    require_once "Auth/OpenID/FileStore.php";
    require_once "Auth/OpenID/SReg.php";
    require_once "Auth/OpenID/PAPE.php";


global $pape_policy_uris;
$pape_policy_uris = array(
    PAPE_AUTH_MULTI_FACTOR_PHYSICAL,
    PAPE_AUTH_MULTI_FACTOR,
    PAPE_AUTH_PHISHING_RESISTANT
);

function &getStore() {
    /**
     * This is where the example will store its OpenID information.
     * You should change this path if you want the example store to be
     * created elsewhere.  After you're done playing with the example
     * script, you'll have to remove this directory manually.
     */
    $store_path = "tmp/openid_consumer"; //надеюсь это хорошая идею без жутких последствий

    if (!file_exists($store_path) &&
            !mkdir($store_path)) {
        print "Could not create the FileStore directory '$store_path'. " .
                " Please check the effective permissions.";
        exit(0);
    }
    $r = new Auth_OpenID_FileStore($store_path);

    return $r;
}

function &getConsumer() {
    /**
     * Create a consumer object using the store object created
     * earlier.
     */
    $store = getStore();
    $r = new Auth_OpenID_Consumer($store);
    return $r;
}

function getScheme() {
    $scheme = 'http';
    if (isset($_SERVER['HTTPS']) and $_SERVER['HTTPS'] == 'on') {
        $scheme .= 's';
    }
    return $scheme;
}

function getReturnTo() {
    return sprintf("%s://%s:%s%s/openid.php",

            getScheme(), $_SERVER['SERVER_NAME'],
            $_SERVER['SERVER_PORT'],
            dirname($_SERVER['PHP_SELF']));
}

function getTrustRoot() {

    return sprintf("%s://%s:%s%s/",
            getScheme(), $_SERVER['SERVER_NAME'],
            $_SERVER['SERVER_PORT'],
            dirname($_SERVER['PHP_SELF']));
}


/* try_auth.php */

session_start();

function getOpenIDURL() {
    // Render a default page if we got a submission without an openid
    // value.
    if (empty($_GET['openid_identifier'])) {
        $error = "Expected an OpenID URL.";
        include 'modules/plugins/openid/index.php'; //TODO а нужно ли это вообще?
        exit(0);
    }

    return $_GET['openid_identifier'];
}

function run_try_openid() {
    $openid = getOpenIDURL();
    $consumer = getConsumer();

    // Begin the OpenID authentication process.
    $auth_request = $consumer->begin($openid);

    // No auth request means we can't begin OpenID.
    if (!$auth_request) {
        displayError("Authentication error; not a valid OpenID.");
    }

    $sreg_request = Auth_OpenID_SRegRequest::build(
                    // Required
                    array('nickname'),
                    // Optional
                    array('fullname', 'email'));

    if ($sreg_request) {
        $auth_request->addExtension($sreg_request);
    }

    $policy_uris = null;
    if (isset($_GET['policies'])) {
        $policy_uris = $_GET['policies'];
    }

    $pape_request = new Auth_OpenID_PAPE_Request($policy_uris);
    if ($pape_request) {
        $auth_request->addExtension($pape_request);
    }

    // Redirect the user to the OpenID server for authentication.
    // Store the token for this authentication so we can verify the
    // response.
    // For OpenID 1, send a redirect.  For OpenID 2, use a Javascript
    // form to send a POST request to the server.
    if ($auth_request->shouldSendRedirect()) {
        $redirect_url = $auth_request->redirectURL(getTrustRoot(),
                        getReturnTo());

        // If the redirect URL can't be built, display an error
        // message.
        if (Auth_OpenID::isFailure($redirect_url)) {
            displayError("Could not redirect to server: " . $redirect_url->message);
        } else {
            // Send redirect.
            header("Location: " . $redirect_url);
        }
    } else {
        // Generate form markup and render it.
        $form_id = 'openid_message';
        $form_html = $auth_request->htmlMarkup(getTrustRoot(), getReturnTo(),
                        false, array('id' => $form_id));

        // Display an error if the form markup couldn't be generated;
        // otherwise, render the HTML.
        if (Auth_OpenID::isFailure($form_html)) {
            displayError("Could not redirect to server: " . $form_html->message);
        } else {
            print $form_html;
        }
    }
}

/*  finish.auth.php */

function escape($thing) {
    return htmlentities($thing);
}

function run_finish_openid() {
    $consumer = getConsumer();

    // Complete the authentication process using the server's
    // response.
    $return_to = getReturnTo();
    $response = $consumer->complete($return_to);

    // Check the response status.
    if ($response->status == Auth_OpenID_CANCEL) {
        // This means the authentication was cancelled.
        $msg = 'Verification cancelled.';
    } else if ($response->status == Auth_OpenID_FAILURE) {
        // Authentication failed; display the error message.
        $msg = "OpenID authentication failed: " . $response->message;
    } else if ($response->status == Auth_OpenID_SUCCESS) {
        // This means the authentication succeeded; extract the
        // identity URL and Simple Registration data (if it was
        // returned).
        $openid = $response->getDisplayIdentifier();
        $esc_identity = escape($openid);

        $success = sprintf('You have successfully verified ' .
                        '<a href="%s">%s</a> as your identity.',
                        $esc_identity, $esc_identity);

        if ($response->endpoint->canonicalID) {
            $escaped_canonicalID = escape($response->endpoint->canonicalID);
            $success .= '  (XRI CanonicalID: ' . $escaped_canonicalID . ') ';
        }

        $sreg_resp = Auth_OpenID_SRegResponse::fromSuccessResponse($response);

        $sreg = $sreg_resp->contents();

        if (@$sreg['email']) {
            $success .= "  You also returned '" . escape($sreg['email']) .
                    "' as your email.";
        }

        if (@$sreg['nickname']) {
            $success .= "  Your nickname is '" . escape($sreg['nickname']) .
                    "'.";
        }

        if (@$sreg['fullname']) {
            $success .= "  Your fullname is '" . escape($sreg['fullname']) .
                    "'.";
        }

        $pape_resp = Auth_OpenID_PAPE_Response::fromSuccessResponse($response);

        if ($pape_resp) {
            if ($pape_resp->auth_policies) {
                $success .= "<p>The following PAPE policies affected the authentication:</p><ul>";

                foreach ($pape_resp->auth_policies as $uri) {
                    $escaped_uri = escape($uri);
                    $success .= "<li><tt>$escaped_uri</tt></li>";
                }

                $success .= "</ul>";
            } else {
                $success .= "<p>No PAPE policies affected the authentication.</p>";
            }

            if ($pape_resp->auth_age) {
                $age = escape($pape_resp->auth_age);
                $success .= "<p>The authentication age returned by the " .
                        "server is: <tt>" . $age . "</tt></p>";
            }

            if ($pape_resp->nist_auth_level) {
                $auth_level = escape($pape_resp->nist_auth_level);
                $success .= "<p>The NIST auth level returned by the " .
                        "server is: <tt>" . $auth_level . "</tt></p>";
            }
        } else {
            $success .= "<p>No PAPE response was sent by the provider.</p>";
        }

        /* all is ok, so is time to rock!!11 */
        openid_login($esc_identity);
    }

    include 'modules/plugins/openid/index.php';
}

function openid_login($openid_identity) {
    $query = os_db_query("SELECT customers_id FROM os_customers WHERE customers_openid = '" . $openid_identity . "'");

    $query_result = os_db_fetch_array($query);

    if (!os_db_num_rows($query)) {
        /* создаем юзера */

        os_redirect(os_href_link("create_account_openid.php", "openid=" . urlencode($openid_identity) . "&")); // добавляем параметр ибо хз как еще его передать

        /* дальше */
    } else {
        $session_started = true; ///?????????

        if (isset($_SESSION['customer_id'])) {
            os_redirect(os_href_link(FILENAME_ACCOUNT, '', 'SSL'));
        }

        if ($session_started == false) {
//            os_redirect(os_href_link(FILENAME_COOKIE_USAGE));
        }

        /* кусок из login.php */

        if (SESSION_RECREATE == 'True') {
            os_session_recreate();
        }

        $check_customer_query = os_db_query("select customers_id, customers_vat_id, customers_firstname,customers_lastname, customers_gender, customers_password, customers_email_address, login_tries, login_time, customers_default_address_id from " . TABLE_CUSTOMERS . " where customers_openid = '" . $openid_identity  . "' and account_type = '0'");
        if (!os_db_num_rows($check_customer_query)) {
            $_GET['login'] = 'fail';
            $info_message = "NO USER!";
        } else {
            $check_customer = os_db_fetch_array($check_customer_query); 
            };


            os_db_query("update " . TABLE_CUSTOMERS . " SET login_tries = 0, login_time = now() WHERE customers_openid = '" . $openid_identity . "'");

            $check_country_query = os_db_query("select entry_country_id, entry_zone_id from " . TABLE_ADDRESS_BOOK . " where customers_id = '" . (int) $check_customer['customers_id'] . "' and address_book_id = '" . $check_customer['customers_default_address_id'] . "'");
            $check_country = os_db_fetch_array($check_country_query);

            $_SESSION['customer_gender'] = $check_customer['customers_gender'];
            $_SESSION['customer_first_name'] = $check_customer['customers_firstname'];
            $_SESSION['customer_last_name'] = $check_customer['customers_lastname'];
            $_SESSION['customer_id'] = $check_customer['customers_id'];
            $_SESSION['customer_vat_id'] = $check_customer['customers_vat_id'];
            $_SESSION['customer_default_address_id'] = $check_customer['customers_default_address_id'];
            $_SESSION['customer_country_id'] = $check_country['entry_country_id'];
            $_SESSION['customer_zone_id'] = $check_country['entry_zone_id'];



            os_db_query("update " . TABLE_CUSTOMERS_INFO . " SET customers_info_date_of_last_logon = now(), customers_info_number_of_logons = customers_info_number_of_logons+1 WHERE customers_info_id = '" . (int) $_SESSION['customer_id'] . "'");
            os_write_user_info((int) $_SESSION['customer_id']);
            // restore cart contents
            $_SESSION['cart']->restore_contents();

            if ($_SESSION['cart']->count_contents() > 0) {
            os_redirect(os_href_link(FILENAME_SHOPPING_CART, '', 'SSL'));
            } else {
                os_redirect(os_href_link(FILENAME_DEFAULT));
            }
        }
    }

    if (($_GET["action"]) == "verify") {
        run_try_openid();
    } else {
        run_finish_openid();
    };

    include ('includes/bottom.php');
?>
